<template>
    <div class="bigscreen-root">
        <div class="ScaleBox" ref="ScaleBox">
            <div class="screen-container">
                <div class="screen-header-wrapper">
                    <div class="leftLine">
                        <img src="@/assets/img/bigScreen/leftLine.svg" />
                    </div>
                    <div class="title">
                        <img src="@/assets/img/bigScreen/title-line.png" />
                    </div>
                    <div class="rightLine">
                        <img src="@/assets/img/bigScreen/rightLine.svg" />
                    </div>
                    <div class="screen-header">

                        <div class="header-center">
                            <div class="screen-header-title">资产管理平台</div>
                            <!-- <div class="screen-header-title" v-if="districtName">
                                改革报表<span class="dot"></span>{{ districtName }}
                            </div>
                            <div class="screen-header-title" v-else>
                                {{ currentMenu.name }}
                            </div> -->
                        </div>
                        <div class="screen-header-nav">
                            <ul class="ul-item">
                                <li class="li-item" v-for="item in frontMenus[0].children" :key="item.key" :class="item.alias == currentKey
                                        ? 'active'
                                        : ''
                                    " @click="changeMenu(item)">
                                    <span>{{ item.name }}</span>
                                </li>
                            </ul>

                        </div>
                        <div class="header-right">
                            <!-- <div class="header-router-btn" v-for="item in menuData" :key="item.id" @click="changeMenu(item)"
                                style="margin-right: 10px">
                                {{ item.name }}
                            </div> -->
                            <div v-if="showWorkPlat" class="header-router-btn" @click="toWorkbench">
                                {{
                                    workPlatMenu && workPlatMenu.length
                                    ? workPlatMenu[0].name
                                    : ''
                                }}
                            </div>
                            <!-- <el-popover placement="bottom" width="80" trigger="hover">
                                <div style="text-align: center; margin: 0">
                                    <el-button size="mini" @click="toggleFullScreen">进入全屏</el-button>
                                    <br />
                                    <el-button size="mini" style="margin: 10px 0 0 0"
                                        @click="toggleFullScreen">退出全屏</el-button>
                                </div>
                                <i class="header-logout el-icon-s-platform" slot="reference"></i>
                            </el-popover> -->
                        </div>
                    </div>
                </div>


                <div class="screen-body">
                    <slot></slot>
                </div>
            </div>
        </div>
    </div>
</template>
<script>
import { mapState } from 'vuex'
import bigScreenMixin from '@/mixins/bigScreenMixin.js'
import moment from 'moment'

export default {
    name: 'screenLayout',
    mixins: [bigScreenMixin],
    props: {
        currentKey: {
            type: String,
            required: true,
        },
    },
    data() {
        return {
            visible: false,
            dataTime: '', //数据生成时间
            // currentKey: 'MajorProjectsView',
            currentMenu: {
                name: '',
            },
            menuData: [],
            showWorkPlat: false,
            districtName: '',
            reportMenu: [
                {
                    name: '市总览',
                    key: 1,
                    link: 'http://23.99.8.1:8080/fvue/zonglan',
                },
                {
                    name: '党建报表',
                    key: 2,
                    link: 'http://23.99.8.1:8080/fvue/dangjian',
                },
                {
                    name: '经济报表',
                    key: 3,
                    link: 'http://23.99.219.238:10003/#/bigscreen/economy-home',
                },
                {
                    name: '平安报表',
                    key: 4,
                    link: 'http://23.211.13.179:32000/#/report-seven',
                },
                {
                    name: '改革报表',
                    key: 5,
                    alias: 'MajorProjectsView',
                    link: 'http://23.99.8.2:8090/fvue/Jump',
                },
                {
                    name: '创新报表',
                    key: 6,
                    link: 'http://23.99.220.103:8200/innovation-screen/#/index',
                },
                {
                    name: '生态报表',
                    key: 7,
                    link: 'http://23.213.61.6:8077',
                },
                {
                    name: '文化报表',
                    key: 8,
                    link: 'http://23.99.8.168:8090',
                },
                {
                    name: '民生报表',
                    key: 9,
                    link: 'http://23.99.219.238:10003/#/bigscreen/livehood-home',
                },
            ],
            reportMenuLeft: [
                {
                    name: '市总览',
                    key: 1,
                    link: 'http://23.99.8.1:8080/fvue/zonglan',
                },
                {
                    name: '党建报表',
                    key: 2,
                    link: 'http://23.99.8.1:8080/fvue/dangjian',
                },
                {
                    name: '经济报表',
                    key: 3,
                    link: 'http://23.99.219.238:10003/#/bigscreen/economy-home',
                },
                {
                    name: '平安报表',
                    key: 4,
                    link: 'http://23.211.13.179:32000/#/report-seven',
                },
            ],
            reportMenuRight: [
                {
                    name: '改革报表',
                    key: 5,
                    alias: 'MajorProjectsView',
                    link: 'http://23.99.8.2:8090/fvue/Jump',
                },
                {
                    name: '创新报表',
                    key: 6,
                    link: 'http://23.99.220.103:8200/innovation-screen/#/index',
                },
                {
                    name: '生态报表',
                    key: 7,
                    link: 'http://23.213.61.6:8077',
                },
                {
                    name: '民生报表',
                    key: 8,
                    link: 'http://23.99.219.238:10003/#/bigscreen/livehood-home',
                },
            ],
            yearOptions: [],
            quarterOptions: [
                {
                    value: 1,
                    label: '1季度',
                },
                {
                    value: 2,
                    label: '2季度',
                },
                {
                    value: 3,
                    label: '3季度',
                    disabled: true
                },
                {
                    value: 4,
                    label: '4季度',
                    disabled: true
                },
            ],
            monthOptions: [
                {
                    value: 1,
                    label: '1月',
                },
                {
                    value: 2,
                    label: '2月',
                },
                {
                    value: 3,
                    label: '3月',
                },
                {
                    value: 4,
                    label: '4月',
                },
                {
                    value: 5,
                    label: '5月',
                },
                {
                    value: 6,
                    label: '6月',
                },
                {
                    value: 7,
                    label: '7月',
                },
                {
                    value: 8,
                    label: '8月',
                },
                {
                    value: 9,
                    label: '9月',
                },
                {
                    value: 10,
                    label: '10月',
                },
                {
                    value: 11,
                    label: '11月',
                },
                {
                    value: 12,
                    label: '12月',
                },
            ],
            month: 1,
            quarter: 2,
            year: 2023,
            fullScreenStatus: false,
            role: ''
        }
    },
    computed: {
        ...mapState({
            frontMenus: (state) => {
                return state.menu.frontMenus
            },
        }),
        optionSingleHeightTime() {
            return {
                step: 0.25,
            }
        },
    },
    created() {
        // 获取用户权限
        let { roleList } = JSON.parse(sessionStorage.getItem('currentUserDetail'))
        let arr = roleList.filter(item => item.roleCode === 'qxdp' || item.roleCode === 'zzb' || item.roleCode === 'sysRole')
        if (arr.length) {
            this.role = 'qxdp'
            this.quarterOptions[2].disabled = false
        }

        this.initYearOption()
        let searchDate = sessionStorage.getItem('searchDate')
        if (searchDate) {
            searchDate = JSON.parse(searchDate)
            this.year = searchDate.year
            this.quarter = searchDate.quarter
            this.month = searchDate.month
        } else {
            this.checkQuarter()
            this.setSearchDate()
        }
        this.getDataTime()
        this.fullScreenStatus = this.isFullscreen()
    },
    watch: {
        currentKey: {
            handler(newVal, oldVal) {
                let Allmenu = []
                Allmenu = this.frontMenus.filter(
                    (item) => item.alias === 'bigScreen'
                )[0].children
                this.currentMenu = Allmenu.filter(
                    (item) => item.alias == newVal
                )[0]
            },
            immediate: true,
        },
    },
    mounted() {
        if (this.$route.query.name) {
            this.districtName = this.$route.query.name
        }
    },
    methods: {
        toggleFullScreen() {
            if (this.fullScreenStatus) {
                this.fullExit()
            } else {
                this.fullScreen()
            }
            this.fullScreenStatus = !this.fullScreenStatus
        },
        //判断是否全屏状态
        isFullscreen() {
            const screen = window.screen
            const body = document.body.getBoundingClientRect()
            return screen.height === body.height && screen.width === body.width
        },
        //进入全屏
        fullScreen() {
            if (document.documentElement.RequestFullScreen) {
                document.documentElement.RequestFullScreen()
            }
            //兼容火狐
            console.log(document.documentElement.mozRequestFullScreen, '111')
            if (document.documentElement.mozRequestFullScreen) {
                document.documentElement.mozRequestFullScreen()
            }
            //兼容谷歌等可以webkitRequestFullScreen也可以webkitRequestFullscreen
            if (document.documentElement.webkitRequestFullScreen) {
                document.documentElement.webkitRequestFullScreen()
            }
            //兼容IE,只能写msRequestFullscreen
            if (document.documentElement.msRequestFullscreen) {
                document.documentElement.msRequestFullscreen()
            }
        },
        //退出全屏
        fullExit() {
            if (document.exitFullScreen) {
                document.exitFullscreen()
            }
            //兼容火狐
            console.log(document.mozExitFullScreen, '222')
            if (document.mozCancelFullScreen) {
                document.mozCancelFullScreen()
            }
            //兼容谷歌等
            if (document.webkitExitFullscreen) {
                document.webkitExitFullscreen()
            }
            //兼容IE
            if (document.msExitFullscreen) {
                document.msExitFullscreen()
            }
        },
        // 数据生成时间当前时间前一天24时
        getDataTime() {
            this.dataTime = moment()
                .subtract(1, 'days')
                .format('YYYY[年]MM[月]DD[日]')
        },
        checkQuarter() {
            let month = new Date().getMonth() + 1
            if (month <= 3) {
                this.quarter = 1
            } else if (month <= 6) {
                this.quarter = 2
            } else if (month <= 9) {
                this.quarter = 3
            } else if (month <= 12) {
                this.quarter = this.role === 'qxdp' ? 3 : 2
            }
            this.month = month
        },
        setSearchDate() {
            let searchDate = {
                year: this.year,
                quarter: this.quarter,
                month: this.month,
            }
            sessionStorage.setItem('searchDate', JSON.stringify(searchDate))
            return searchDate
        },
        changeDate() {
            let searchDate = this.setSearchDate()
            this.$bus.$emit('changeDate', searchDate)
        },
        initYearOption() {
            let year = new Date().getFullYear()
            this.year = year
            for (let i = 0; i < 5; i++) {
                this.yearOptions.push({
                    value: year - i,
                    label: year - i,
                })
            }
        },
        // 8张报表菜单切换
        changeTab(item) {

            this.$router.push({
                path: `/${item.alias}`,
            })
        },
        // 改革驾驶舱菜单切换
        changeMenu(item) {
            this.$router.push({
                path: `/${item.alias}`,
            })
        },
    },
}
</script>
<style lang="scss" scoped>
@import '@/assets/css/big-screen.scss';

.dot {
    display: inline-block;
    width: 10PX;
    height: 10PX;
    border-radius: 10PX;
    margin: 0 16PX 0 12PX;
    background: linear-gradient(0deg, #8dc7ff 0%, #ffffff 100%);
    vertical-align: middle;
}

.data-push-time {
    margin-top: 20PX;
    font-size: 14PX;
    font-weight: 400;
    font-family: Source Han Sans CN;
    color: #cae5ff;
    margin-left: 10PX;
}
</style>
